/********************************************************

   vFace

 ********************************************************/
/*

   - HUOM! texture ja drawMode eivt voi olla staattisia muuttujia,
     koska piirrettess tasoja, ne eivt (vlttmtt) tule
     objekteittain vaan satunnaisessa jrjestyksess ts.
     ne voivat saada vrt tekstuurit

*/

import java.awt.Graphics;
import java.awt.Polygon;
import java.awt.Color;

public class vFace
{
   private static vFace[] bucket = initBuckets();
   private static vFace[] emptyBucket = initBuckets();

   public static int[] environment = null;

   public final static int DOT = 0;
   public final static int LINE = 1;
   public final static int CONST = 2;
   public final static int FLAT = 3;
   public final static int GOURAUD = 4;
   public final static int PHONG = 5;
   public final static int CONST_TEXTURE = 6;
   public final static int FLAT_TEXTURE = 7;
   public final static int GOURAUD_TEXTURE = 8;
   public final static int PHONG_TEXTURE = 9;
   public final static int PHONG_BUMPTEXTURE = 13;

   public static boolean awtMode = false;
   public static int drawMode = CONST;

   public static int worldTimeStamp = 0;

   public static int width, height;
   public static int[] videoBuffer = null;
   public static Graphics videoGraphics = null;

   public static vTexture texture;

   private static float wx, wy, wz;
   public static float r00, r01, r02;
   public static float r10, r11, r12;
   public static float r20, r21, r22;

   public static float d0, d1, d2;

   public static float cx, cy, cz;     // kameran paikka suhteessa obuun
   public static float lx, ly, lz;     // valonlhteen paikka suhteessa obuun
                                       // normalisoituna vakiopituiseksi
                                       /* hassu dilemna:
                                          tll tavalla voi kytt
                                          vain yht valoa, vaikka
                                          teoriassa olisi ihan helppoa
                                          laittaa niit enemmnkin

                                          hintana olisi se, ett
                                          kukin valonlhde pitisi
                                          ksitell erikseen (listana?)
                                          ja jokaisesta tulisi 3 kerto-
                                          laskua lis
                                       */

   public int brightness = 0;

   public static vVertex activeVertexList = null;

   public static vObject currentObject = null;
   private static int objectTimeStamp;

   int faceColor;

   vVertex p1 = null;
   vVertex p2 = null;
   vVertex p3 = null;

   vEdge e1 = null;
   vEdge e2 = null;
   vEdge e3 = null;

   boolean e1_inverse = false;
   boolean e2_inverse = false;
   boolean e3_inverse = false;

   vVertex topVertex;
   vVertex bottomVertex;
   vVertex sideVertex;

   vEdge longEdge;
   vEdge topEdge;
   vEdge bottomEdge;

   float e1_k;
   float e2_k;
   float e3_k;

   float top_k;
   float bottom_k;
   float long_k;

   float lConst = 0;             // 1 / pitkn sivun pituus
   float pConst = 0;             // p:n laskemiseen tarvittava vakio
   float wConst = 0;

   int xAdder = 1;

//   boolean longEdgeInv;
//   boolean topEdgeInv;
//   boolean bottomEdgeInv;

   public int faceZ = 0;

   vFace nextFace = null;
   vFace nextActiveFace = null;

   vNormal faceNormal = null;    // pisteen normaali

   public int timeStamp = 0;

   private boolean noClipping;

   private static vFace[] initBuckets()
   {
      vFace[] temp = new vFace[256];

      for(int i=0;i<256;i++)
         temp[i] = null;
      return temp;
   }

/********************************************************


 ********************************************************/

   public vFace( vFace faceList, vVertex np1, vVertex np2, vVertex np3 )
   {
      nextFace = faceList;

      p1 = np1;
      p2 = np2;
      p3 = np3;

// lasketaan normaali...
      calcNormal();
   }

/********************************************************

   calcNormal()

   - laskee tason normaalin reunavektorien ristitulolla

 ********************************************************/

   public final static float roundConst = (1.0F / 2.0F);

   private vNormal calcNormal()
   {
      int x,y,z;

      float x1,y1,z1,x2,y2,z2;
      float fx,fy,fz,r;

      x1 = p1.x - p2.x;
      y1 = p1.y - p2.y;
      z1 = p1.z - p2.z;

      x2 = p3.x - p2.x;
      y2 = p3.y - p2.y;
      z2 = p3.z - p2.z;

      fx = (y1*z2-y2*z1);
      fy = (z1*x2-z2*x1);
      fz = (x1*y2-x2*y1);

      r = 1000.0F / (float) Math.sqrt(fx*fx+fy*fy+fz*fz);

      x = (int) (fx * r + roundConst);
      y = (int) (fy * r + roundConst);
      z = (int) (fz * r + roundConst);

      faceNormal = new vNormal( x, y, z );
      return faceNormal;
   }

/********************************************************


 ********************************************************/

   public vFace mergeList( vFace activeList )
   {
      vFace temp = nextActiveFace;
      vFace temp2 = nextActiveFace;

      while(temp != null)
      {
         temp2 = temp;
         temp = temp.nextActiveFace;
      }

      temp2.nextActiveFace = activeList;
      return this;
   }

// yhdist limittin molemmat listat

   public vFace sortMergeList( vFace activeList )
   {
      return mergeList( activeList );
   }


// huom. pit list listan loppuun, optimoi!!
   public vFace addToList( vFace activeFace )
   {
      nextActiveFace = activeFace;
      return this;
   }

   public void fillBuckets( int c )
   {
      vFace temp = this;
      vFace temp2 = null;
      int   scale = c << 3;
      int i;

      while(temp != null)
      {
         temp2 = temp.nextActiveFace;     // otetaan seuraava talteen

         i = (temp.faceZ >> scale) & 255;

// optimoi tm tohon if lauseseen sislle.
         if (bucket[i] == null)
         {
            emptyBucket[i] = temp;
         }
         else
         {
            bucket[i].nextActiveFace = temp;
         }

         bucket[i] = temp;

         temp = temp2;
      }
   }

   public static vFace mergeBuckets()
   {
      vFace returnValue = null;
      vFace lastEmpty = null;
      int i,j;

      for(i=255;i>=0;i--)
      {
         if (bucket[i] != null)
         {
            returnValue = emptyBucket[i];
            lastEmpty = bucket[i];

            bucket[i] = null;
            break;
         }
      }
      for(j=i;j>=0;j--)
      {
         if(bucket[j] != null)
         {
            lastEmpty.nextActiveFace = emptyBucket[j];
            lastEmpty = bucket[j];

            bucket[j] = null;
         }
      }

      if (lastEmpty != null) lastEmpty.nextActiveFace = null;

      return returnValue;
   }

/********************************************************

   vFace prepareFlat()

 ********************************************************/

   public vFace prepareFlat()
   {
// tason kirkkaus lasketaan 1. kulman paikan perusteella, eik
// suinkaan tason keskipisteen. tapa on (ylltten) vr. :-)
      float tempx = p1.x + lx;
      float tempy = p1.y + ly;
      float tempz = p1.z + lz;

      float nx = faceNormal.x;
      float ny = faceNormal.y;
      float nz = faceNormal.z;

// tt ei voi laskea ihan nin, koska tss pits lisksi olla
// steen pituus...

/*

idea toimisi hyvin, jos ensin laskisi valonlhteen etisyyden objektista
siit riippuen kytettisiin joko ko. objektin valovektoria (jos etisyys
suuri) tai polygonikohtaista valovektoria

*/


      brightness = (int) (tempx * nx + tempy * ny + tempz * nz);
      return nextActiveFace;
   }

/********************************************************

   vFace prepareGouraud()

 ********************************************************/

   public vFace prepareGouraud()
   {
      p1.prepareGouraud();
      p2.prepareGouraud();
      p3.prepareGouraud();

      return nextActiveFace;
   }

/********************************************************

   vFace prepareGouraud()

 ********************************************************/

   public vFace preparePhong()
   {
      p1.preparePhong();
      p2.preparePhong();
      p3.preparePhong();

      return nextActiveFace;
   }

/********************************************************

   vFace addIfVisible( vFace )

   in:   nkyvien tasojen lista
   out:  uusi nkyvien tasojen lista

   funktio:

   jos taso nkyy, niin se listn listan alkuun. samalla
   tason vertexit pyritetn ja projisoidaan.

 ********************************************************/

   public vFace addIfVisible( vFace activeFace )
   {
      float tempx = p1.x + cx;
      float tempy = p1.y + cy;
      float tempz = p1.z + cz;

      float nx = faceNormal.x;
      float ny = faceNormal.y;
      float nz = faceNormal.z;

//      System.out.println("face: (no clipping) camera at ("+tempx+", "+tempy+", "+tempz+
//         ") normal = ("+nx+", "+ny+", "+nz+")");

// jos taso on vrin pin, ei merkit sit aktiiviseksi
      if (drawMode != LINE)
         if ((tempx * nx + tempy * ny + tempz * nz) < 0) return activeFace;

// muutoin rotatoidaan ja projisoidaan vertexit

      noClipping = true;

      p1.rotateProject();
      p2.rotateProject();
      p3.rotateProject();

// listn taso listaan

      nextActiveFace = activeFace;
      return this;
   }

/********************************************************


 ********************************************************/
   public vFace addIfVisible_HorizClip( vFace activeFace )
   {
      return addIfVisible_Clip( activeFace );
   }

   public vFace addIfVisible_VertClip( vFace activeFace )
   {
      return addIfVisible_Clip( activeFace );
   }

   public vFace addIfVisible_DepthClip( vFace activeFace )
   {
      return addIfVisible_Clip( activeFace );
   }

   public vFace addIfVisible_Clip( vFace activeFace )
   {
      float tempx = p1.x + cx;
      float tempy = p1.y + cy;
      float tempz = p1.z + cz;

      float nx = faceNormal.x;
      float ny = faceNormal.y;
      float nz = faceNormal.z;

// jos taso on vrin pin, ei merkit sit aktiiviseksi
      if (drawMode != LINE)
         if ((tempx * nx + tempy * ny + tempz * nz) < 0 ) return activeFace;

// muutoin rotatoidaan ja projisoidaan vertexit

      p1.rotate();
      if (p1.rz < 0) return activeFace;

      p2.rotate();
      if (p2.rz < 0) return activeFace;

      p3.rotate();
      if (p3.rz < 0) return activeFace;

      faceZ = (int) p1.rz;
//      faceZ = p1.rz + p2.rz + p3.rz;

//      System.out.println("Face in front of cam. (ok)");

      int leftClip = 0;
      int rightClip = 0;
      int topClip = 0;
      int bottomClip = 0;

      p1.project();
      p2.project();
      p3.project();

      noClipping = false;

      if (p1.px < 0) { leftClip++; } else if (p1.px >= width) { rightClip++; }

      if (p1.py < 0) { topClip++; } else if (p1.py >= height) { bottomClip++; }


      if (p2.px < 0) { leftClip++; } else if (p2.px >= width) { rightClip++; }

      if (p2.py < 0) { topClip++; } else if (p2.py >= height) { bottomClip++; }


      if (p3.px < 0) { leftClip++; } else if (p3.px >= width) { rightClip++; }

      if (p3.py < 0) { topClip++; } else if (p3.py >= height) { bottomClip++; }

//      System.out.println( leftClip+" "+rightClip+" "+topClip+" "+bottomClip);

      if ((leftClip == 3) || (rightClip == 3) ||
          (topClip == 3) || (bottomClip == 3)) return activeFace;

//      System.out.println("Face not totally off screen (ok!)");

      if ((leftClip | rightClip | topClip | bottomClip) == 0) noClipping = true;

// listn taso listaan

      nextActiveFace = activeFace;
      return this;
   }


/********************************************************

   drawFaceList( w,h,vbuffer )

   - kutsuu drawFace():a

 ********************************************************/

   public void drawFaceList( int now, int w, int h, int[] vb )
   {

      worldTimeStamp = now;

      videoBuffer = vb;

      vEdge.videoBuffer = vb;
      vEdge.width = w;
      vEdge.height = h;

// iteratiivinen ratkaisu...
      vFace temp = this;

      if (awtMode)
      {
         while( temp != null )
         {
            temp.awtDrawFace();
            temp = temp.nextActiveFace;
         }
      }
      else
      {
//         if (drawMode == LINE)

         vEdge.worldTimeStamp = worldTimeStamp;

         while( temp != null )
         {
            temp.drawFace();
            temp = temp.nextActiveFace;
         }
      }

//      if (awtMode) awtDrawFace(); else drawFace();

   }

/********************************************************

   drawFace()

   - piirt tason ruudulle, clippaa tarvittaessa

   - mahdollisia piirtotapoja:

      - dot draw (awt)        (vain vertexit)
      - line draw (awt)       (vain reunat->edget)
      - smooth line draw      (vain edget, smoothattuna)
      - const flat fill (awt) (fillatut vakiovriset polygonit)
      - flat fill (awt)       (fillatut varjostetut polygonit)
      - gouraud fill          (gouraudfillatut polygonit)
      - texture fill          (tekstuuripinnoitetut polygonit)
      - texture fill++?       (mipmap, bipolar, etc. tekstuurit)
      - gouraud texture fill  (gouraudvarjostetut tekstuurit)
      - gouraud texture fill++?

      - phong?
      - phong texture?
      - zblur (=focus)?
      - zbuffer?

 ********************************************************/

   public void drawFace()
   {
      switch (drawMode)
      {
         case DOT:
         {
            if (noClipping)
            {
               int offs = p1.py * width + p1.px;
               videoBuffer[ offs ] = 0xffffffff;
               offs = p2.py * width + p2.px;
               videoBuffer[ offs ] = 0xffffffff;
               offs = p3.py * width + p3.px;
               videoBuffer[ offs ] = 0xffffffff;
            }
            else
            {
               int offs;
               if ((p1.py & 0xffff) < height &&
                   (p1.px & 0xffff) < width)
               {
                  offs = p1.py * width + p1.px;
                  videoBuffer[ offs ] = 0xffffffff;
               }
               if ((p2.py & 0xffff) < height &&
                   (p2.px & 0xffff) < width)
               {
                  offs = p2.py * width + p2.px;
                  videoBuffer[ offs ] = 0xffffffff;
               }
               if ((p3.py & 0xffff) < height &&
                   (p3.px & 0xffff) < width)
               {
                  offs = p3.py * width + p3.px;
                  videoBuffer[ offs ] = 0xffffffff;
               }
            }
            break;
         }

         case LINE:
         {
            if (noClipping)
            {
               e1.drawEdge();
               e2.drawEdge();
               e3.drawEdge();
            }
            else
            {
               e1.drawClipEdge();
               e2.drawClipEdge();
               e3.drawClipEdge();
            }
            break;
         }

         case FLAT:
         {
            int r = faceColor & 0x0000ff;
            int g = faceColor & 0x00ff00;
            int b = faceColor & 0xff0000;

            r = ((r * brightness) >> 8) & 0x0000ff;
            g = ((g * brightness) >> 8) & 0x0000ff;
            b = ((b * brightness) >> 8) & 0x0000ff;

            constFill( r | g | b );
            break;
         }
         case CONST:
         {
            constFill( faceColor );
            break;
         }
         case PHONG:
         {
            phongFill();
            break;
         }
         case FLAT_TEXTURE:
         {

         }
         case CONST_TEXTURE:
         {

            break;
         }
      }
// rekursiivinen tapa... ei hyv, stacki kuormittuu hitosti!
//      if (nextActiveFace != null) nextActiveFace.drawFace();
   }

/********************************************************

   awtDrawFace()

 ********************************************************/

   static int[] awtFaceX = {0,0,0};
   static int[] awtFaceY = {0,0,0};

   final static Polygon awtFace = new Polygon( awtFaceX, awtFaceY, 3 );

   Color flatColor = null;
   Color constColor = new Color( 0xffffff );
   Color fillColor = null;

   public void awtDrawFace()
   {
      fillColor = constColor;

// piirretn taso
      switch (drawMode)
      {
         case DOT:
         {
            videoGraphics.setColor( fillColor );

            videoGraphics.drawLine( p1.px, p1.py, p1.px, p1.py );
            videoGraphics.drawLine( p2.px, p2.py, p2.px, p2.py );
            videoGraphics.drawLine( p3.px, p3.py, p3.px, p3.py );
            break;
         }

         case LINE:
         {
            videoGraphics.setColor( fillColor );

            awtFaceX[0] = p1.px;
            awtFaceX[1] = p2.px;
            awtFaceX[2] = p3.px;

            awtFaceY[0] = p1.py;
            awtFaceY[1] = p2.py;
            awtFaceY[2] = p3.py;

            videoGraphics.drawPolygon( awtFaceX, awtFaceY, 3 );
            break;
         }

         case FLAT:
         {
            fillColor = flatColor;
         }
         case CONST:
         {
            videoGraphics.setColor( fillColor );

            awtFaceX[0] = p1.px;
            awtFaceX[1] = p2.px;
            awtFaceX[2] = p3.px;

            awtFaceY[0] = p1.py;
            awtFaceY[1] = p2.py;
            awtFaceY[2] = p3.py;

            videoGraphics.drawPolygon( awtFaceX, awtFaceY, 3 );
//            videoGraphics.fillPolygon( awtFace );
            break;
         }

         case FLAT_TEXTURE:
         {

         }
         case CONST_TEXTURE:
         {

            break;
         }
      }
// rekursiivinen tapa... ei hyv, stacki kuormittuu hitosti!
//      if (nextActiveFace != null) nextActiveFace.awtDrawFace();
   }

/********************************************************

   void prepareFill()

   in:   -
   out:  -

   valmistelee fillauksen:
      - etsii ylimmn pisteen
      - valitsee pitkn sivun
      - laskee gouraud ja teksture adderit
      - laskee kulma-adderit

 ********************************************************/

   public final void prepareFill()
   {
// sorttaus

/*

   1) otetaan pisin edge
   2) tutkitaan mik vertex on sen ylpss
   3) tutkitaan kumpi jljelle jneist edgeist on ylempn

*/
//      e1_k = (e1_inverse) ? -e1.getAngle() : e1.getAngle();
//      e2_k = (e2_inverse) ? -e2.getAngle() : e2.getAngle();
//      e3_k = (e3_inverse) ? -e3.getAngle() : e3.getAngle();

      e1_k = e1.getAngle();
      e2_k = e2.getAngle();
      e3_k = e3.getAngle();

      if (e1.ady > e2.ady)
      {
         if (e1.ady > e3.ady)
         {

// e1 = p1 -> p2 pisin

            longEdge = e1;

            if (p1.py < p2.py)
            {
               topEdge = e3;
               bottomEdge = e2;

               long_k = e1_k;
               top_k = e3_k;
               bottom_k = e2_k;

               topVertex = p1;
               bottomVertex = p2;
               sideVertex = p3;
            }
            else
            {
               topEdge = e2;
               bottomEdge = e3;

               long_k = e1_k;
               top_k = e2_k;
               bottom_k = e3_k;

               topVertex = p2;
               bottomVertex = p1;
               sideVertex = p3;
            }
         }
         else
         {

// e3 = p3 -> p1 pisin

            longEdge = e3;

            if (p1.py < p3.py)
            {
               topEdge = e1;
               bottomEdge = e2;

               long_k = e3_k;
               top_k = e1_k;
               bottom_k = e2_k;

               topVertex = p1;
               bottomVertex = p3;
               sideVertex = p2;
            }
            else
            {
               topEdge = e2;
               bottomEdge = e1;

               long_k = e3_k;
               top_k = e2_k;
               bottom_k = e1_k;

               topVertex = p3;
               bottomVertex = p1;
               sideVertex = p2;
            }
         }
      }
      else
      {
         if (e2.ady > e3.ady)
         {
// e2 = p2 -> p3 pisin

            longEdge = e2;

            if (p2.py < p3.py)
            {
               topEdge = e1;
               bottomEdge = e3;

               long_k = e2_k;
               top_k = e1_k;
               bottom_k = e3_k;

               topVertex = p2;
               bottomVertex = p3;
               sideVertex = p1;
            }
            else
            {
               topEdge = e3;
               bottomEdge = e1;

               long_k = e2_k;
               top_k = e3_k;
               bottom_k = e1_k;

               topVertex = p3;
               bottomVertex = p2;
               sideVertex = p1;
            }
         }
         else
         {

// e3 = p3 -> p1 pisin  ( hitto pitk se taas tehd 2 kertaa? )

            longEdge = e3;

            if (p1.py < p3.py)
            {
               topEdge = e1;
               bottomEdge = e2;

               long_k = e3_k;
               top_k = e1_k;
               bottom_k = e2_k;

               topVertex = p1;
               bottomVertex = p3;
               sideVertex = p2;
            }
            else
            {
               topEdge = e2;
               bottomEdge = e1;

               long_k = e3_k;
               top_k = e2_k;
               bottom_k = e1_k;

               topVertex = p3;
               bottomVertex = p1;
               sideVertex = p2;
            }
         }
      }

      int   dy = topEdge.ady;
      int   dx = topEdge.dx;

//      lConst = 0F;
      lConst = (1.0F / (longEdge.ady));
      pConst = 0F;
      wConst = 0F;

      if (dy != 0)
      {
         pConst = lConst * topEdge.ady;

         int x = sideVertex.px - (topVertex.px + (int) ((bottomVertex.px - topVertex.px) * pConst + roundConst));
         if (x > 0) wConst = (1.0F / x);
         else if (x < 0) wConst = (-1.0F / x);

         if (long_k < top_k)
         {
            xAdder = 1;
         }
         else
         {
            xAdder = -1;
         }
      }
      else
      {
         int x = topEdge.adx;
         if (x != 0) wConst = (1.0F / x);

         if (topVertex.px < sideVertex.px)
         {
            xAdder = 1;
         }
         else
         {
            xAdder = -1;
         }
      }
   }

   public final void constFill( int color )
   {
      prepareFill();

      int y = topVertex.py;
      int x0 = topVertex.px;
      int x1 = x0 + xAdder;

      int offs = 0;
      float x1F = 0;
      float x0F = 0;
      float x1a = 0;
      float x0a = 0;

//      if (longEdge == e1) color = 0xffff0000;
//      if (longEdge == e2) color = 0xff00ff00;
//      if (longEdge == e3) color = 0xff0000ff;

   try
   {
      if (noClipping)
      {
// polygonissa ei mitn klipattavaa (kokonaan ruudulla)
         offs = y * width;
         if (xAdder < 0) offs--;

         x0F = x0;
         x1F = x0F + xAdder;
         x0a = long_k;
         x1a = top_k;

         if (topEdge.ady == 0)
         {
            x1 = sideVertex.px + xAdder;
            x1F = x1;
         }
         else
         {
            for(int i=0;i<topEdge.ady;i++)
            {
               x0 = (int) x0F;
               x1 = (int) x1F;

               for(int j=offs + x0;j!=offs + x1;j+=xAdder)
               {
                  videoBuffer[j] = color;
               }

               offs += width;
               x0F += x0a;
               x1F += x1a;
            }
         }

         x1a = bottom_k;

         for(int i=0;i<bottomEdge.ady;i++)
         {
            x0 = (int) x0F;
            x1 = (int) x1F;

            for(int j=offs + x0;j!=offs + x1;j+=xAdder)
            {
               videoBuffer[j] = color;
            }

            offs += width;
            x0F += x0a;
            x1F += x1a;
         }
      }
      else
      {
// polygonissa on jotain klipattavaa
// ylreunan clippaus
         if (y<0)
         {
//            x1 -= xAdder * side_k * y;
//            x0 -= xAdder * long_k * y;
            y = 0;
         }

         offs = y * width + x0;
      }

   } catch (Exception e)
   {
      System.out.println("offs = " + offs + " x0F = " + x0F + " x0a = " + x0a +
         " x1F = " + x1F + " x1a = " + x1a);
      System.out.println("y = " + (offs / width) + " longEdge.ady = " + longEdge.ady + " topEdge.ady = " +
         topEdge.ady + " bottomEdge.ady = " + bottomEdge.ady + " xAdder = " + xAdder);
      System.out.println();
   }

   }

   public final void phongFill()
   {
      prepareFill();

      float tex = topVertex.ex;
      float tey = topVertex.ey;
      float bex = bottomVertex.ex;
      float bey = bottomVertex.ey;

      float ex_row_a = bex - tex;
      float ey_row_a = bey - tey;

      float pex = tex + ex_row_a * pConst;
      float pey = tey + ey_row_a * pConst;

      float ex_col_a = (sideVertex.ex - pex) * wConst;
      float ey_col_a = (sideVertex.ey - pey) * wConst;

      ex_row_a *= lConst;
      ey_row_a *= lConst;

      float rex = tex;
      float rey = tey;

      float ex, ey;

      int y = topVertex.py;
      int x0 = topVertex.px;
      int x1 = x0 + xAdder;

      int offs = 0;
      float x1F = 0;
      float x0F = 0;
      float x1a = 0;
      float x0a = 0;

//      if (longEdge == e1) color = 0xffff0000;
//      if (longEdge == e2) color = 0xff00ff00;
//      if (longEdge == e3) color = 0xff0000ff;

   try
   {
      if (noClipping)
      {
// polygonissa ei mitn klipattavaa (kokonaan ruudulla)
         offs = y * width;
         if (xAdder < 0) offs--;

         x0F = x0;
         x1F = x0F + xAdder;
         x0a = long_k;
         x1a = top_k;

         if (topEdge.ady == 0)
         {
            x1 = sideVertex.px + xAdder;
            x1F = x1;
         }
         else
         {
            for(int i=0;i<topEdge.ady;i++)
            {
               x0 = (int) x0F;
               x1 = (int) x1F;

               ex = rex;
               ey = rey;

               for(int j=offs + x0;j!=offs + x1;j+=xAdder)
               {
//                  videoBuffer[j] = environment[(((int) ey) << 8) + (int) (ex)];

                  int iey = ((int) ey) & 255;
                  int iex = ((int) ex) & 255;

                  videoBuffer[j] = environment[(iey << 8) + iex];

//                  videoBuffer[j] = environment[((128) << 8) + 128];
//                  videoBuffer[j] = color;
                  ex += ex_col_a;
                  ey += ey_col_a;
               }

               rex += ex_row_a;
               rey += ey_row_a;

               offs += width;
               x0F += x0a;
               x1F += x1a;
            }
         }

         x1a = bottom_k;

         rex = pex;
         rey = pey;

         for(int i=0;i<bottomEdge.ady;i++)
         {
            x0 = (int) x0F;
            x1 = (int) x1F;

            ex = rex;
            ey = rey;

            for(int j=offs + x0;j!=offs + x1;j+=xAdder)
            {
               int iey = ((int) ey) & 255;
               int iex = ((int) ex) & 255;

               videoBuffer[j] = environment[(iey << 8) + iex];

               ex += ex_col_a;
               ey += ey_col_a;
            }

            rex += ex_row_a;
            rey += ey_row_a;

            offs += width;
            x0F += x0a;
            x1F += x1a;
         }
      }
      else
      {
// polygonissa on jotain klipattavaa

         int topCount = topEdge.ady;
         int bottomCount = bottomEdge.ady;

// alareunan (triviaali) clippaus
         if (y+topCount >= height)
         {
            topCount = height - y - 1;
            bottomCount = 0;
         }
         else
         if (sideVertex.py+bottomCount >= height)
         {
            bottomCount = height - sideVertex.py - 1;
         }

         offs = y * width;

         x0F = x0;
         x1F = x0F + xAdder;
         x0a = long_k;
         x1a = top_k;

         if (sideVertex.py >= 0)
         {
            if (y < 0)
            {
               x0F -= long_k * y;
               x1F -= top_k * y;

               topCount += y;

               rex -= ex_row_a * y;
               rey -= ey_row_a * y;

               y = offs = 0;
            }

            if (xAdder < 0) offs--;

            for(int i=0;i<topCount;i++)
            {
               x0 = (int) x0F;
               x1 = (int) x1F;

               ex = rex;
               ey = rey;

               int start = x0;
               int end = x1;

               if (xAdder < 0)
               {
                  if (end < 0) end = 0;

                  if (start < 0)
                  {
                     end = start;
                  }
                  else
                  if (end > width)
                  {
                     end = start;
                  }
                  else
                  if (start > width)
                  {
                     int m = start - width;
                     ex += ex_col_a * m;
                     ey += ey_col_a * m;
                     start = width;
                  }
               }
               else
               {
                  if (end > width) end = width;

                  if (start >= width)
                  {
                     end = start;
                  }
                  else
                  if (end < 0)
                  {
                     end = start;
                  }
                  else
                  if (start < 0)
                  {
                     ex -= ex_col_a * start;
                     ey -= ey_col_a * start;
                     start = 0;
                  }
               }

               for(int j=offs+start;j!=offs+end;j+=xAdder)
               {
                  int iey = ((int) ey) & 255;
                  int iex = ((int) ex) & 255;

                  videoBuffer[j] = environment[(iey << 8) + iex];

                  ex += ex_col_a;
                  ey += ey_col_a;
               }

               rex += ex_row_a;
               rey += ey_row_a;

               offs += width;
               x0F += x0a;
               x1F += x1a;
            }
         }

         x1 = sideVertex.px + xAdder;
         x1F = x1;

         x1a = bottom_k;

         rex = pex;
         rey = pey;

         y = sideVertex.py;

         offs = y * width;

         if (y < 0)
         {
            x0F = topVertex.px - long_k * topVertex.py;
            x1F -= bottom_k * y;

            bottomCount += y;

            rex -= ex_row_a * y;
            rey -= ey_row_a * y;

            y = offs = 0;
         }

         if (xAdder < 0) offs--;

         for(int i=0;i<bottomCount;i++)
         {
            x0 = (int) x0F;
            x1 = (int) x1F;

            ex = rex;
            ey = rey;

            int start = x0;
            int end = x1;

            if (xAdder < 0)
            {
               if (end < 0) end = 0;

               if (start < 0)
               {
                  end = start;
               }
               else
               if (end > width)
               {
                  end = start;
               }
               else
               if (start > width)
               {
                  int m = start - width;
                  ex += ex_col_a * m;
                  ey += ey_col_a * m;
                  start = width;
               }
            }
            else
            {
               if (end > width) end = width;

               if (start >= width)
               {
                  end = start;
               }
               else
               if (end < 0)
               {
                  end = start;
               }
               else
               if (start < 0)
               {
                  ex -= ex_col_a * start;
                  ey -= ey_col_a * start;
                  start = 0;
               }
            }

            for(int j=offs+start;j!=offs+end;j+=xAdder)
            {
               int iey = ((int) ey) & 255;
               int iex = ((int) ex) & 255;

               videoBuffer[j] = environment[(iey << 8) + iex];

               ex += ex_col_a;
               ey += ey_col_a;
            }

            rex += ex_row_a;
            rey += ey_row_a;

            offs += width;
            x0F += x0a;
            x1F += x1a;
         }
      }

   } catch (Exception e)
   {
      System.out.println("offs = " + offs + " x0F = " + x0F + " x0a = " + x0a +
         " x1F = " + x1F + " x1a = " + x1a);
      System.out.println("y = " + (offs / width) + " longEdge.ady = " + longEdge.ady + " topEdge.ady = " +
         topEdge.ady + " bottomEdge.ady = " + bottomEdge.ady + " xAdder = " + xAdder);
      System.out.println();
   }

   }
}
