/*******************************************************

   tp7 demo - sonik klique

 *******************************************************/

import java.awt.*;
import java.awt.image.*;
import java.applet.*;
import java.net.*;
import java.io.*;

public class demo extends Applet implements Runnable {

   Thread myThread;

   int[] videoBuffer = null;
   MemoryImageSource videoSource;

   Image videoImage;
   int[] imgbuf = null;

   int   width = 360;
   int   height = 180;

   Graphics vidg = null;

   URL codeBase = null;

   boolean nosound = false;

   long demoStartTime = 0;

   int demoStage = 0;         // tmn hetkinen vaihe
   int nextStageAt = -1;      // seuraavan vaiheen aika

   int demoEnd = 100000;      // demo loppuu thn vaiheeseen

   int[] demoEventList = { 6800, 9250, 11700, 14250, // mercy 1

                           14800, 15430, 16060, 16690, 17320,   // huudot 5
                           17950, 18580, 19210, 19840, 20470,   // 10
                           21100, 21730, 22360, 22990, 23620,   // 15
                           24250,                   // 20

                           24650,                   // 21 skrolli sisn

                           27100, 27717, 28334, 28951, // 22 very very very arrogant
                           29568, 30185, 30802, 31419, // 26
                           32036, 32653, 33270, 33887, // 30

                           34500,                   // 34 vekit keskelle

                           41900,                   // 35 vekit pois

                           44400,                   // 36 very pois

                           46700, 47400, 48100, 48600, // 37

                           51600, 54200,           // 41

                           61000,                  // 43 balls alkaa poistua

                           64000,                  // 44	(64000)

                           71600,                  // 45 lines sisn (46)

                           74800,                  // 46 liikennemerkki (47)

                           78000,                  // 47 halo sisn (48)

                           86000,                  // 48 center

                           88700,                  // 49 sydn kuva

                           93500,                  // 50 radial kulmaan

                           96100,                  // 51 chaos sisn

                           112100,                 // 52 chaos fade

                           115100,                 // 53 kone

                           134000,                 // 54 konefade

                           138000,                 // 55 loppu anim...

                           200000,
                           400000};

   public void init() {

      super.init();

      codeBase = getCodeBase();

      setLayout( null );

      width = size().width;
      height = size().height;

      mapwidth = width * 6 / 5;
      mapheight = height * 6 / 5;
      mapmodulo = mapwidth - width;

      videoImage = createImage(width,height);
      vidg = videoImage.getGraphics();

      vidg.setColor(Color.white);
      vidg.fillRect(0,0,width,height);
      vidg.setColor(Color.black);
      vidg.drawString("wait...",4,14);

      if (getParameter("nosound") != null) nosound = true;
   }

/*******************************************************

 *******************************************************/

   public void start()
   {
      repaint();
//      System.out.println("start()");

      if (myThread == null)
      {
         myThread = new Thread( this, "Demothread" );
      }
      myThread.start();
   }

   public void stop()
   {
//      System.out.println("stop()");

      if (myThread != null) myThread.stop();
      myThread = null;

      cleanup();
   }

   public void cleanup()
   {
      if (muzah != null) muzah.stop();

      myWorld = null;
      myWorld2 = null;

      haloAnim = null;
      greetsAnim = null;
      logoAnim = null;
      mercyh = null;
      egoImages = null;
      screamImages = null;

      muzah = null;

      System.gc();
   }

   Animation myAnimation = null;

   private vWorld myWorld = null;
   private vWorld myWorld2 = null;

   private AudioClip muzah = null;

   boolean restart = false;

   public void run()
   {
      if (restart)
      {
// nyt restart kuva!

	   videoImage = getImage(getCodeBase(), "error.gif");		
	   waitImage(videoImage);

	   repaint();

         return;
      }

      restart = true;
//      System.out.println("run()");

      javalogo = getImage(codeBase, "javalogo.gif");
      emptybar = getImage(codeBase, "emptybar.gif");
      fullbar = getImage(codeBase, "fullbar.gif");
      ostext = getImage(codeBase, "ostext.gif");

      waitImage(javalogo);
      waitImage(emptybar);
      waitImage(fullbar);
      waitImage(ostext);

      osstart(0,0);

      if (!nosound && muzah == null)
      {
         muzah = getAudioClip(codeBase, "dela2.au");
      }

      if (videoBuffer == null)
      {
         videoBuffer = new int[width * height];
         videoSource = new MemoryImageSource(width, height, videoBuffer, 0, width);

         for(int i=0;i<width*height;i++)
            videoBuffer[i] = 0xffffffff;
      }

      osstart(0,10);
      initCredits();
      osstart(0,50);
      initScroll();
      osstart(0,100);
//      wait(400);
      osstart(1,20);
      initBalls();
      osstart(1,80);
      initLines();
      osstart(1,100);
//      wait(400);
      osstart(2,20);
      initHalo();
      osstart(2,60);
      initChaos();
      osstart(2,80);
      initMercy();
      osstart(2,100);
//      wait(400);
      osstart(3,100);

//      demoStage = -1;
//      nextStageAt = 0;

//      System.out.println("right before playing");

      javalogo = null;
      emptybar = null;
      fullbar = null;
      ostext = null;

      System.gc();

      if (muzah != null) muzah.play();
//      System.out.println("playing???");

      demoStartTime = System.currentTimeMillis();

      timeStamp = System.currentTimeMillis();
      time2 = System.currentTimeMillis();

      checkEvent();

      if (!playMercy()) stop();

	smtrash[0].flush();
	smtrash[1].flush();
	smtrash[2].flush();
	smtrash = null; 

	walkImage.flush();
	walkImage = null; 

	trashImage.flush();
	trashImage = null; 

	mercyh = null; 
      egoImages = null; 
      screamImages = null; 

      if (!playScroll()) stop();

//      myWorld = null;

      if (!playBalls()) stop();
      if (!playLines()) stop();

//      myWorld2 = null;

      framen = 0;    // kludgie
      frameinc = 1;

      if (!playHalo()) stop();

      astage = 0;
      astage2 = 120;

      if (!playChaos()) stop();

      framen = 0;
      frameinc = 1;
      if (!playCredits()) stop();

      cleanup();

      initPlayAnim();

      if (myThread != null) stop();
   }
/*
   public boolean playEnvVectors()
   {
      for(int i=0;i<360*180;i++)
      {
         videoBuffer[i] = 0xffffffff;
      }
      myWorld.updateWorld();
      myWorld.renderView();
      return renderView();
   }
*/
/*
   public boolean playVectors()
   {

      for(int i=0;i<360*180;i++)
      {
         videoBuffer[i] = 0; //&= 0xff;  //0xff000000;
      }

      myWorld.renderView();
      myWorld.updateWorld();

      int[] background = myAnimation.getIntFrame(framen);

      framen += frameinc;

      if ((framen & 0xff) >= myAnimation.count)
      {
         frameinc = - frameinc;
         framen += frameinc;
      }

      for(int i=0;i<360*180;i++)
      {
         int v = (videoBuffer[i] >> 3) ^ 127;
//            if (v > 255) v = 255;
//            videoBuffer[i] = 0xff000000 | (0x10101 * v);

         if ((v & 0xffff) > 127) v = 0;

         int rb = background[i] ^ 0xffffffff;
         int g = rb & 0x00ff00;
         rb &= 0xff00ff;

         videoBuffer[i] = ((((rb * v) & 0x7f807f80)
                        | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;


      }
      return renderView();
   }
*/

   int frameinc = 1;

   int framen = 0;

   public boolean playAnim(Animation myAnimation)
   {
      int[] myFrame = myAnimation.getIntFrame(framen);

      for(int i=0;i<width*height;i++)
      {
         videoBuffer[i] = myFrame[i];
      }

      if (++framen >= myAnimation.count) framen = 0;

      return renderView();
   }

   public void donebar(int n)
   {
      if (vidg == null) return;
      vidg.fillRect(6,32,(width-12) * n / mapcount, 6);
      repaint();
   }

/*******************************************************

 *******************************************************/

   long time2 = 0;
   long timeStamp = 0;
   long prevTimeStamp = 0;
   long delay;
/*
   public final boolean renderView()
   {
      return renderView(null);
   }
*/
   public final boolean renderImage(Image img)
   {
      if (myThread == null) return false;

      while(!frameDone) {
         if ((timeStamp - System.currentTimeMillis()) > 2000)
         {
            frameDone = true;
//            System.out.println("bailed out!");
         }

         try {
            Thread.sleep(15);
         } catch (InterruptedException e) {}
      }

      long dd = System.currentTimeMillis() - time2;
      time2 = System.currentTimeMillis();

//      if (videoImage != null) videoImage.flush();
//      videoImage = null;

      videoImage = img;

      prepareImage(videoImage, null);
      while((checkImage(videoImage, null) & ImageObserver.ALLBITS) == 0 )
      {
//         if (verbose) System.out.println("   waiting for image...");
         try { Thread.sleep(10); } catch(InterruptedException e) {}
      }

      delay = (timeStamp += 70) - System.currentTimeMillis();

      try {
         if (delay > 10) Thread.sleep(delay);
         else {
            timeStamp = System.currentTimeMillis();
            Thread.sleep(10);
         }
      } catch (InterruptedException e) {};

      frameDone = false;
      repaint();

      while(!frameDone) {
         if ((timeStamp - System.currentTimeMillis()) > 2000)
         {
            frameDone = true;
//            System.out.println("bailed out!");
         }

         try {
            Thread.sleep(15);
         } catch (InterruptedException e) {}
      }

      return checkEvent();
   }

   public final boolean renderView()
   {
      if (myThread == null) return false;

      while(!frameDone) {
         if ((timeStamp - System.currentTimeMillis()) > 2000)
         {
            frameDone = true;
//            System.out.println("bailed out!");
         }

         try {
            Thread.sleep(15);
         } catch (InterruptedException e) {}
      }
/*
      long dd = System.currentTimeMillis() - time2;
      time2 = System.currentTimeMillis();

      for(int i=0;i<dd;i++) videoBuffer[i] = 0xffff0000;
*/
      if (videoImage != null) videoImage.flush();
      videoImage = null;
      if (videoSource != null) videoImage = createImage(videoSource);

      prepareImage(videoImage, null);
      while((checkImage(videoImage, null) & ImageObserver.ALLBITS) == 0 )
      {
//         if (verbose) System.out.println("   waiting for image...");
         try { Thread.sleep(10); } catch(InterruptedException e) {}
      }

      delay = (timeStamp += 70) - System.currentTimeMillis();

      try {
         if (delay > 10) Thread.sleep(delay);
         else {
            timeStamp = System.currentTimeMillis();
            Thread.sleep(10);
         }
      } catch (InterruptedException e) {};

      frameDone = false;
      repaint();

      return checkEvent();
   }

   public void waitImage(Image ttt)
   {
      prepareImage(ttt, null);
      while((checkImage(ttt, null) & ImageObserver.ALLBITS) == 0 )
      {
         try { Thread.sleep(10); } catch(InterruptedException e) {}
      }
   }

   public boolean wait(int msec)
   {
      try{
         Thread.sleep(70);
      } catch(InterruptedException e) {}

      timeStamp = System.currentTimeMillis();
      return checkEvent();
   }

   public boolean checkEvent()
   {
      if (demoStage == demoEnd) return false;

      if (timeStamp - demoStartTime > nextStageAt)
      {
         try {
            nextStageAt = demoEventList[demoStage];
         } catch (ArrayIndexOutOfBoundsException e)
         {
            return false;
         }
         demoStage++;

//         System.out.println("stage " + demoStage + " at " + (timeStamp-demoStartTime));
      }
      return true;
   }

/*******************************************************

 *******************************************************/

   public Animation loadAnim(String animName, int frames)
   {
      return loadAnim(animName, frames, Animation.INTARRAY);
   }

   public Animation loadAnim(String animName, int frames, int flags)
   {
      Animation myAnim = new Animation(animName, frames);
      String animStub = animName.substring(0, animName.indexOf("."));
      String animExt = animName.substring(animName.indexOf("."), animName.length());

      for(int i=0;i<frames;i++)
      {
         String frameName = animStub + i + animExt;
//         System.err.println(animName + " at frame " + i + " ("+frameName+")");

         try {
            Image tempIm = getImage(codeBase, frameName);
            prepareImage(tempIm, null);
            myAnim.setFrame(i, tempIm, flags);
         } catch (Exception e)
         {
            System.err.println("Exception during preparation of animation " + animName + " at frame " + i + " ("+frameName+")");
            return null;
         }
      }

      return myAnim;
   }
/*******************************************************

   ball fx

 *******************************************************/

   int[] ballFilter = null;

   byte[] ballArray = null;
   int[] ballSinTable = null;

   final double ballGlowValue = 185.0;

   public void initBalls()
   {
      try {
         ballsbg = Animation.grabImage(getImage(codeBase, "ballsbg.jpg"));
      } catch (Exception e) {};

      ballArray = new byte[256*256];
      ballSinTable = new int[256];

      int offs = 0;

      for(int v=0;v<256;v++)
      {
         for(int u=0;u<256;u++)
         {
            double d = Math.sqrt((128-u)*(128-u)+(128-v)*(128-v));

//            ballArray[offs++] = (byte) (Math.cos((128-v)*Math.PI/256.0)
//                                       *Math.cos((128-u)*Math.PI/256.0)*127);
            if (d > 127.0) d = 127.0;
//            ballArray[offs++] = (byte) (Math.cos(d * Math.PI/256.0) * 127);
//            ballArray[offs++] = (byte) (127.0-d);
            d = 1 - (d / 127.0);
            d = (ballGlowValue * d * d);
            if (d>127.0) d = 127.0;
            ballArray[offs++] = (byte) (d);
         }

//         ballSinTable[v] = (((int) (Math.sin(v * Math.PI / 512.0)*256)) * 0x10101) | 0xff000000;
//         ballSinTable[v] = (int) (Math.sin(v * Math.PI / 512.0)*256);

// mieti viel loppuun t homma... reunat ei nyt ihan kivalta...
         if (v < 128)
//            ballSinTable[v] = (int) (Math.sqrt(v/127.0) * 127) ^ 127;
            ballSinTable[v] = (int) (Math.cos(Math.sqrt(v/127.0) * Math.PI / 2.0) * 127); // ^ 127;
      }

      greetBuf = new byte[3][];
      byte[] tempb = Animation.grabMask(Animation.grabImage(getImage(codeBase, "greets0.gif")), 7400);
      greetBuf[1] = Animation.grabMask(Animation.grabImage(getImage(codeBase, "greets1.gif")), 15884);
      greetBuf[2] = Animation.grabMask(Animation.grabImage(getImage(codeBase, "greets2.gif")), 50456);
			
	greetBuf[0] = new byte[7400*2];
	for(int i=0;i<7400;i++) 
	{ 
		greetBuf[0][i] = tempb[i];
		greetBuf[0][i+7400] = tempb[i];
	}
   }

   double[] ballCoords = {  0,  0,  0,  0,  0,  0,
                           20,  0,  0,  0,  0,  0,
                            0, 20,  0,  0,  0,  0,
                            0,  0, 20,  0,  0,  0};

   int[] greetData = { 60,90,148,50,
                       50,50,209,76,
                       -40,60,371,136 };

   byte[][] greetBuf = null;
   int[] ballsbg = null;

   int greetLayers = 0;
   int ballFadeVal = 127;

   public boolean playBalls()
   {
//      System.out.println("play them balls");
// pallot sisn + layerit synkeiss

      while (demoStage < 42)
      {
         if (ballFadeVal > 0) ballFadeVal -= 16;
         if (ballFadeVal < 0) ballFadeVal = 0;

         greetLayers = demoStage-38;

         for(int i=0;i<360*180;i++) videoBuffer[i] = ballFadeVal;
         moveBalls();
         drawBalls();

         if (!renderView()) return false;
      }

/*
//      System.out.println("lighter");
// "i'm the *est mc in the woooerld"
      ballFadeVal = 0;

      while(demoStage == 42)
      {
         for(int i=0;i<360*180;i++) videoBuffer[i] = ((videoBuffer[i] & 255) >> 1);
//         moveBalls();
         drawBalls();

         if (!renderView()) return false;
      }

//      System.out.println("mc out?");
*/

      while(demoStage < 44)
      {
         for(int i=0;i<360*180;i++) videoBuffer[i] = ballFadeVal;
         moveBalls();
         drawBalls();

         if (!renderView()) return false;
      }

//      System.out.println("balls fading out");

      while(demoStage == 44)
      {
         if (ballFadeVal < 127) ballFadeVal += 10;
         if (ballFadeVal > 127) ballFadeVal = 127;

         for(int i=0;i<360*180;i++) videoBuffer[i] = ballFadeVal;
         moveBalls();
         drawBalls();

         if (!renderView()) return false;
      }

      return true;
   }

   public void moveBalls()
   {
      for(int i=0;i<greetLayers;i++)
      {
         int y = greetData[i*4+1];

         drawAddLayer(greetBuf[i], greetData[i*4], y, greetData[i*4+2], greetData[i*4+3]);

         y -= (i+1) * 3;

         if (y + greetData[i*4+3] < 0)
         {
            y = height;
            int w = greetData[i*4+2];
            greetData[i*4] = (int) (Math.random() * 360) - w/2;
         }

         greetData[i*4+1] = y;
      }

      for(int i=0;i<4;i++)
      {
         ballCoords[i*6+0] += ballCoords[i*6+3];
         ballCoords[i*6+1] += ballCoords[i*6+4];
         ballCoords[i*6+2] += ballCoords[i*6+5];
      }

      for(int i=0;i<4;i++)
      {
         double x0 = ballCoords[i*6+0];
         double y0 = ballCoords[i*6+1];
         double z0 = ballCoords[i*6+2];

//         double t = Math.sqrt(x0*x0+y0*y0+z0*z0);

         double xv = -0.06 * x0 + Math.random() * 3.0 - 1.5;
         double yv = -0.06 * y0 + Math.random() * 3.0 - 1.5;
         double zv = -0.06 * z0 + Math.random() * 3.0 - 1.5;

         for(int j=0;j<4;j++)
         {
            if (j!=i)
            {
               double dx = (x0 - ballCoords[j*6+0]);
               double dy = (y0 - ballCoords[j*6+1]);
               double dz = (z0 - ballCoords[j*6+2]);

               double dist2 = (dx * dx + dy * dy + dz * dz);
               dist2 = 100.0 / (1.0 + dist2 * Math.sqrt(dist2));

               xv += dx * dist2;
               yv += dy * dist2;
               zv += dz * dist2;
            }
         }

         ballCoords[i*6+3] = ballCoords[i*6+3] * 0.95 + xv * 0.5;
         ballCoords[i*6+4] = ballCoords[i*6+4] * 0.95 + yv * 0.5;
         ballCoords[i*6+5] = ballCoords[i*6+5] * 0.95 + zv * 0.5;
      }
   }

   public void drawBalls()
   {
      for(int i=0;i<4;i++)
      {
         drawScaleBall(videoBuffer,
                       ballCoords[i*6+0],
                       ballCoords[i*6+1],
                       ballCoords[i*6+2]);
      }

      for(int i=0;i<360*180;i++)
      {
         int v = videoBuffer[i];
         if ((v & 0xefffffff) > 127) v = 127;

         v = ballSinTable[v];

//         v ^= 127;

         int rb = ballsbg[i] ^ -1;
         int g = rb & 0x00ff00;
         rb &= 0xff00ff;
/*
         int rb1 = ballFilter[i];
         int g1 = rb1 & 0x00ff00;
         rb1 &= 0xff00ff;

         videoBuffer[i] = ((((rb * (256-v) + rb1 * v) & 0xff00ff00)
                        | ((g * (256-v) + g1 * v) & 0x00ff0000)) >> 8)
                        | 0xff000000;
*/

         videoBuffer[i] = ((((rb * v) & 0x7f807f80)
                           | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;
      }
   }

   final static double dConst = 300.0;

   public void drawAddLayer(byte[] source, int topx, int topy, int w, int h)
   {
	int ty = topy; 
      int dw = w;
      int dh = h;
      int soffs = 0;

      int xp = 0;
      int yp = 0;

      if (topx >= 360 || topx+dw < 0 || topy >= 180 || topy+dh < 0) return;

      if (topx < 0)
      {
         dw += topx;             // vhennetn leveytt
         xp -= topx;
         topx = 0;
      }

      if (topx+dw > 360)
      {
         dw = 360-topx;
      }

      if (topy < 0)
      {
         dh += topy;
         yp -= topy;
         topy = 0;
      }

      if (topy+dh > 180)
      {
         dh = 180-topy;
      }

//      dh --;

      int doffs = topx + topy * 360;

      soffs = yp * w + xp;

      for(int v=0;v<dh;v++)
      {
         for(int u=0;u<dw;u++)
         {
            videoBuffer[doffs++] += (int) source[soffs++];
         }

         doffs += (360 - dw);
         soffs += (w - dw);
	}
   }

   private final void drawScaleBall(int[] dest, double x, double y, double z)
   {
      double scale = (dConst / (z+40.0));

      int dx = 180 + (int) (x * scale);
      int dy = 90 + (int) (y * scale);
/*
      if (((dx & 0xffff) < 360) && ((dy & 0xffff) < 180))
      {
         videoBuffer[dy*360+dx] = 0xff;
      }
//*/
///*
      int edge = (int) (256 / 10 * scale);

      int topx = dx - edge / 2;
      int topy = dy - edge / 2;

      int soffs = 0;
      int dw = edge;
      int dh = edge;

      int adder = (int) (65536 * 10 / scale);

      int xp = 0;
      int yp = 0;

      if (topx >= 360 || topx+edge < 0 || topy >= 180 || topy+edge < 0) return;

      if (topx < 0)
      {
         dw += topx;             // vhennetn leveytt
         xp = - topx * adder;
         topx = 0;
      }

      if (topx+dw > 360)
      {
         dw = 360-topx;
      }

      if (topy < 0)
      {
         dh += topy;
         yp = - topy * adder;
         topy = 0;
      }

      if (topy+dh > 180)
      {
         dh = 180-topy;
      }

      dh --;

      int doffs = topx + topy * 360;
      int nx = xp;

      for(int v=0;v<dh;v++)
      {
         int yoffs = (yp >> 16) * 256;

         for(int u=0;u<dw;u++)
         {
            soffs = yoffs + ((xp += adder) >> 16);

            dest[doffs++] += (int) ballArray[soffs];
         }

         doffs += (360-dw);
         xp = nx;
         yp += adder;
      }
//*/
   }



/*******************************************************

   halo fx

 *******************************************************/

   int haloWX = 0;
   int haloWY = 10;

   double haloMorph = 1;

   public boolean playHalo()
   {
// demoStage == 48

      while(demoStage == 48)
      {
         if (haloRange < 50) haloRange += 2;

         if (haloMorph > 0) haloMorph -= 0.05;

         drawHalo(haloAnim.getIntFrame(framen / 2), haloMask0);

         framen += frameinc;

         if ((framen & 0xff) >= haloAnim.count * 2)
         {
            frameinc = - frameinc;
            framen += (frameinc*4);
         }

         if (!renderView()) return false;
      }

      haloWX = 90;
      haloWY = 38;

      while(demoStage == 49)
      {
         if (haloRange > 8) haloRange -= 2;

         if (haloMorph < 1.0) haloMorph += 0.05;

         drawHalo(haloAnim.getIntFrame(framen / 2), haloMask0);

         framen += frameinc;

         if ((framen & 0xff) >= haloAnim.count*2)
         {
            frameinc = - frameinc;
            framen += (frameinc*4);
         }

         if (!renderView()) return false;
      }

      while(demoStage == 50)
      {
         if (haloRange < 70) haloRange += 2;

         if (haloMorph > 0) haloMorph -= 0.05;

         drawHalo(haloAnim.getIntFrame(framen / 2), haloMask1);

         framen += frameinc;

         if ((framen & 0xff) >= haloAnim.count * 2)
         {
            frameinc = - frameinc;
            framen += (frameinc*4);
         }

         if (!renderView()) return false;
      }

      haloWX = 180;
      haloWY = 70;

      while(demoStage == 51)
      {
         if (haloRange > 20) haloRange -= 1;

//         if (haloMorph < 1.0) haloMorph += 0.02;

         drawHalo(haloAnim.getIntFrame(framen / 2), haloMask1);

         framen += frameinc;

         if ((framen & 0xff) >= haloAnim.count * 2)
         {
            frameinc = - frameinc;
            framen += (frameinc*4);
         }

         if (!renderView()) return false;
      }

      return true;
   }

   public void initHalo()
   {
      haloAnim = loadAnim("end.jpg", 11);

      makeHaloTables();
      try {
         haloMask0 = Animation.grabImage(getImage(codeBase, "radial0.gif"));
         haloMask1 = Animation.grabImage(getImage(codeBase, "radial1.gif"));
      } catch (Exception e) {};

      for(int i=0;i<4*90*45;i++) haloMask0[i] = (haloMask0[i] & 0xff) >> 2;
      for(int i=0;i<4*90*45;i++) haloMask1[i] = (haloMask1[i] & 0xff) >> 2;
   }

   Animation haloAnim = null;

   int haloX = 90;
   int haloY = 45;

   int[] haloMask = null;
   int[] haloMask0 = null;
   int[] haloMask1 = null;

   final static int abs(int c)
   {
      int s = c >> 32;
      return (c ^ s - s);
   }

   final static int haloAngles = 200;  // erisuuntaisten steiden mr
   final static int haloRanges = 50;   // kehien lukumr  (=45*100 sdett)
   final static int maxHaloRange = 101;// suurin sde

   final static int haloWidth = 90;

   final int[] haloValues = new int[haloAngles*maxHaloRange];

   int[] haloBuffer = null;

   int   haloRange = 40;

   double haloAngle = 0.0;

   public void drawHalo(int[] background, int[] mask)
   {
      astage ++;
      astage2 ++;

	if (timeStamp - prevTimeStamp > 140) 
	{
	   astage ++; 
	   astage2 ++; 
	}
	prevTimeStamp = timeStamp; 

      int y0 = (int) (haloWY * haloMorph + (1.0-haloMorph) *
                     (22 * (2.0 + Math.sin(astage*0.06) + Math.sin(astage2*0.0317))));
      int x0 = (int) (haloWX * haloMorph + (1.0-haloMorph) *
                     (45 * (2.0 - Math.sin(astage*0.071) - Math.sin(astage2*0.0235))));

      int center = y0 * haloWidth + x0;
      int hoffs = 0;

//      x0 += (int) (Math.random() * 3) - 1;
//      y0 += (int) (Math.random() * 3) - 1;

      x0 <<= 16;
      y0 <<= 16;

      int v = 0;

      for(int i=0;i<180*90;i++)
      {
//         v = (v >> 1 + haloBuffer[i]) >> 1;
//         haloBuffer[i] = v;

         v = haloBuffer[i];
         haloBuffer[i] = (v+v+v) >> 2;
      }

      for(int angle=0;angle<haloAngles;angle++)
      {
         int range = 0;
         int value = 0;

         int rmult = 32768;// * haloRange / haloRanges;
         double fangle = Math.random() * 0.1 + angle * 2.0 * Math.PI / (haloAngles * 1.0);

         int dy = (int) (Math.cos(fangle) * rmult);
         int dx = (int) (Math.sin(fangle) * rmult * 2);

         int hx = x0;
         int hy = y0;
         int soffs;

//         dx = 0; dy = 0;

//         if (((y & 0xffff) >= 45) || ((x & 0xffff) >= 90)) break;

         for(;range<haloRange;range++)
         {
            int y = ((hy += dy) >> 16);
            int x = ((hx += dx) >> 16);

            if ((y & 0xffff) >= 90 || (x & 0xffff) >= 180) break;

            soffs = y * 180 + x;

//            value = mask[haloOffs[soffs]]; // + ((value + value + value) >> 2);
//            value = mask[soffs] + ((value + value + value) >> 2);
            value = mask[soffs] + ((value * 7) >> 3);
            haloBuffer[soffs] += value;
         }

         while(true)
         {
            int y = ((hy += dy) >> 16);
            int x = ((hx += dx) >> 16);

            if ((y & 0xffff) >= 90 || (x & 0xffff) >= 180) break;

            soffs = y * 180 + x;

//            value = ((value + value + value) >> 2);
            haloBuffer[soffs] += value;
         }

/*
         for(;range<haloRange;range++)
         {
            int y = ((hy += dy) >> 16);
            int x = ((hx += dx) >> 16);

            if (((y & 0xffff) >= 45) || ((x & 0xffff) >= 90)) break;

            int soffs = (y * haloWidth + x);

            value = mask[soffs]; //(value >> 1) + mask[soffs];
            haloValues[hoffs++] = value;
         }

         for(;range<maxHaloRange;range++)
         {
            haloValues[hoffs++] = value;
         }
*/
      }

      int offs = 0;

      hoffs = 0;

      for(int y=-y0;y<90-y0;y++)
      {
         for(int x=-x0;x<180-x0;x++)
         {
//            int v = haloValues[(quickAngle(x,y) * maxHaloRange) + quickRange(x,y)];

            v = (haloBuffer[hoffs++] * 128 / (7*256)) ^ 127;
            if ((v & 0xffff) > 127) v = 0;

            int rb = background[offs] ^ 0xffffffff;
            int g = rb & 0x00ff00;
            rb &= 0xff00ff;

            videoBuffer[offs] = ((((rb * v) & 0x7f807f80)
                              | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;

            rb = background[offs+1] ^ 0xffffffff;
            g = rb & 0x00ff00;
            rb &= 0xff00ff;

            videoBuffer[offs+1] = ((((rb * v) & 0x7f807f80)
                              | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;


            rb = background[offs+width] ^ 0xffffffff;
            g = rb & 0x00ff00;
            rb &= 0xff00ff;

            videoBuffer[offs+width] = ((((rb * v) & 0x7f807f80)
                              | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;

            rb = background[offs+width+1] ^ 0xffffffff;
            g = rb & 0x00ff00;
            rb &= 0xff00ff;

            videoBuffer[offs+width+1] = ((((rb * v) & 0x7f807f80)
                              | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;

            offs += 2;
         }

         offs += width;
      }
   }

   int[] haloOffs = null;

   public void makeHaloTables()
   {
/*
      quickSqrt = new int[maxHaloRange*maxHaloRange];
      for(int i=0;i<maxHaloRange*maxHaloRange;i++)
      {
         quickSqrt[i] = (int) (Math.sqrt(i));
      }
*/
      haloBuffer = new int[180*90];

      haloOffs = new int[180*90];

      int offs = 0;

      for(int y=-45;y<45;y++)
      {
         for(int x=-90;x<90;x++)
         {
            haloOffs[offs++] = ((y + 45) / 2) * haloWidth + (x + 90) / 2;
         }
      }
   }

   int ma = 0;
   int mx = 0;
   int my = 0;
   int mran = 0;



/*******************************************************


   fluxfield...


 *******************************************************/


   int[] vectMap0 = null;
   int[] vectMap1 = null;

   int[][] vectMapArray = null;

   int   mapwidth = 200*6/5;
   int   mapheight = 200*6/5;

   int   mapmodulo = mapwidth - width;

   int mapx = mapmodulo / 4;
   int mapy = mapmodulo / 2;

   int amapx = mapmodulo / 4;
   int amapy = mapmodulo / 2;

   boolean automove = true;

   int astage = 0;
   int astage2 = 120;

   int bgstage = 20;
   boolean bgon = false;

   int mstage = 5;

   int fxstage = 10;
   int fxmode = 0;
   int fxsin=0;
   int fxsin2 = 124;
   int fxrb = 0;
   int fxg = 0;
   boolean fxon = false;

   int mapid = 0;
   int mapcount = 4;

   public void setmap(int id)
   {
      mapid = id % mapcount;
      vectMap0 = vectMapArray[mapid];
   }

/*******************************************************

 *******************************************************/

   private int[] finishMap(int[] temp)
   {
      int offs = 0;
      int i,j;
      int mod2 = mapmodulo / 2;

      for(int y=0;y<mapheight;y++)
      {
         for(int x=0;x<mapwidth;)
         {
            i = temp[offs];
            j = i >> 16;
            i <<= 16;
            i >>= 16;

            i += (x-mod2);
            if (i < 0) i = 0;
            else
            if (i >= width) i = width-1;

            j += (y-mod2);
            if (j < 0) j = 0;
            else
            if (j >= height) j = height-1;

            temp[offs++] = j * width + (i & 0xfffe) + 1;

            x++;

            i = temp[offs];
            j = i >> 16;
            i <<= 16;
            i >>= 16;

            i += (x-mod2);
            if (i < 0) i = 0;
            else
            if (i >= width) i = width-1;

            j += (y-mod2);
            if (j < 0) j = 0;
            else
            if (j >= height) j = height-1;

            temp[offs++] = j * width + (i & 0xfffe);

            x++;
         }
      }

      return temp;
   }

/*******************************************************

 *******************************************************/

   private int[] sinusMap(int[] temp, double xsp, double xm, double ysp, double ym)
   {
      double xa = 0.0;
      double ya = 0.0;
      double xaa = 0.0;
      double yaa = 0.0;
      int p;
      int ptr = 0;

      double u, v;

      for(int i=0;i<mapheight;i++)
      {
         ya = (yaa += xsp);
         xa = (xaa += ysp);

         for(int j=0;j<mapwidth;j++)
         {
            u = xm * Math.sin((xa+=xsp));
            v = ym * Math.sin((ya+=ysp));

            p = (((int) u) & 0x0000fffe);

            temp[ptr] += p;

            p = (int) v;
            temp[ptr++] += p << 16; //* width;
         }
      }
      return temp;
   }

/*******************************************************

 *******************************************************/

   private int[] tileMap(int[] temp, int x, int y)
   {
      if (x==1 && y == 1) return temp;

      int w = mapwidth / x;
      int h = mapheight / y;

      int[] source = new int[w*h];

      int src = ((mapheight - h) / 2) * mapwidth + (mapwidth - w) / 2;
      int offs = 0;

      for(int v=0;v<h;v++)
      {
         for(int u=0;u<w;u++)
         {
            source[offs++] = temp[src++];
         }
         src += mapwidth - w;
      }

      src = 0;

      for(int j=0;j<y;j++)
      {
         for(int i=0;i<x;i++)
         {
            src = j * h * mapwidth + i * w;
            offs = 0;

            for(int v=0;v<h;v++)
            {
               for(int u=0;u<w;u++)
               {
                  temp[src++] = source[offs++];
               }
               src += mapwidth - w;
            }
         }
      }

      return temp;
   }

/*******************************************************

 *******************************************************/

   private int[] zoomMap( int[] temp, int x0, int y0, double m )
   {
      return zoomMap( temp, x0, y0, m, 0, 1, 0 );
   }

   private int[] zoomMap( int[] temp, int x0, int y0, double m, int phase, int c, int dist )
   {
// tekee zoomereita, bonuksena suunnasta & etisyydest riippuva zoomeri
      double u,v;
      int   p, ptr = 0;

      x0 += (mapwidth - width) / 2;
      y0 += (mapheight - height) / 2;

      {
         for(int i=0;i<mapheight;i++)
            for(int j=0;j<mapwidth;j++)
            {
               u = ((x0-j) * (c + Math.sin(phase * Math.atan2(x0-j, y0-i))) * m) + 0.5;
               v = ((y0-i) * (c + Math.sin(phase * Math.atan2(x0-j, y0-i))) * m) + 0.5;

               p = (((int) u) & 0x0000fffe);

               temp[ptr] += p;

               p = (int) v;
               temp[ptr++] += p << 16; //* width;
            }
      }

      return temp;
   }

/*******************************************************

 *******************************************************/

   private int[] rotateMap( int[] temp, int x0, int y0, double r, double velocity )
   {
      double u,v;
      int   p, ptr = 0;

      x0 += (mapwidth - width) / 2;
      y0 += (mapheight - height) / 2;

      if (r==0)
      {
         for(int i=0;i<mapheight;i++)
            for(int j=0;j<mapwidth;j++)
            {
// lasketaan liikevektorit (helppo... t rotatoi)
               u = ((y0-i) * velocity) + 0.5;
               v = ((j-x0) * velocity) + 0.5;

// huomaa halpa doublebufferointi! framet on interlacettu pystysuunnassa
               p = (((int) u) & 0xfffe);

               temp[ptr] += p;

               p = (int) v;
               temp[ptr++] += p << 16;// * width;
            }
      }
      else
      {
         double R;

         for(int i=0;i<mapheight;i++)
            for(int j=0;j<mapwidth;j++)
            {
// lasketaan liikevektorit (helppo... t rotatoi)

               R = 1 / (1 + ((y0-i)*(y0-i) + (x0-j)*(x0-j)) * r );

               u = ((y0-i) * velocity * R) + 0.5;
               v = ((j-x0) * velocity * R) + 0.5;

// huomaa halpa doublebufferointi! framet on interlacettu pystysuunnassa
               p = (((int) u) & 0xfffe);

               temp[ptr] += p;

               p = (int) v;
               temp[ptr++] += p << 16; //* width;
            }
      }

      return temp;
   }

/*******************************************************

 *******************************************************/



/*******************************************************

 *******************************************************/

   int videoStage = 0;

   final int r_ptr = 2;
   final int g_ptr = 0;
   final int b_ptr = -2;

   private void makeWorldGo()
   {
      int   ptr,i,j;
      int   vptr0, vptr1;
      int   r,g,b;

      ptr = videoStage;
      vptr0 = videoStage + mapx * 2 + mapy * mapwidth;

      videoStage = (1 - videoStage);
   try {
      if (bgon)
      {
         for(int y=0;y<height;y++)
         {
            for(int x=0;x<width/2;x++)
            {
               i = (videoBuffer[ptr] & 0x00fcfcfc);

               videoBuffer[ptr] =
                  ((((((imgbuf[ptr]+i) & 0x01f9f9f9)+i+i) >> 2)
                  + (videoBuffer[vectMap0[vptr0]] & 0x00fcfcfc)) >> 1)
                  | 0xff000000;

/*
               videoBuffer[ptr] =
                  (((((videoBuffer[ptr] & 0x00fcfcfc) + imgbuf[ptr]) >> 1)
                  + (videoBuffer[vectMap0[vptr0]] & 0x00fefefe)) >> 1)
                  | 0xff000000;
*/
               ptr += 2;
               vptr0 += 2;
            }
            vptr0 += mapmodulo;
         }
      }
      else
      {
         for(int y=0;y<height;y++)
         {
            for(int x=0;x<width/2;x++)
            {
               videoBuffer[ptr] =
                  (((videoBuffer[ptr] & 0x00fefefe)
                  + (videoBuffer[vectMap0[vptr0]] & 0x00fefefe)) >> 1)
                  | 0xff000000;

               ptr += 2;
               vptr0 += 2;
            }
            vptr0 += mapmodulo;
         }
      }
   } catch(ArrayIndexOutOfBoundsException e)
   {

   }
   }

   private boolean frameDone = true;

/*******************************************************

 *******************************************************/


   public void paint( Graphics g )
   {
      if (videoImage != null)
      {
         g.drawImage( videoImage, 0, 0, null );
      }
      frameDone = true;
   }

   public void update( Graphics g )
   {
      paint( g );
   }

/*******************************************************

 *******************************************************/

   public void drawFx(int dx, int dy)
   {
      int offs = dy * width + dx;

      int v = (int) (63 * Math.sin(fxsin*0.12+0.30))+128;

      for(int y=0;y<8;y++)
      {
         for(int x=0;x<8;x++)
         {
            int rb0 = videoBuffer[offs];
            int g0 = rb0 & 0x00ff00;
            rb0 &= 0xff00ff;

            videoBuffer[offs++] =
               (((fxrb * v + rb0 * (256-v)) >> 8) & 0xff00ff)
               + (((fxg * v + g0 * (256-v)) >> 8) & 0x00ff00)
               | 0xff000000;
         }
         offs+=width-8;
      }
   }

/*******************************************************

   vectorfx

 *******************************************************/

   public vWorld initVectors(String dobfile, int shading)
   {
      vWorld tempWorld = new vWorld(360,180,videoBuffer,shading);

      if (!tempWorld.isWorldLoaded())
      {
         URL DOBSource = null;
         DataInputStream DOBStream = null;

         try {
            DOBSource = new URL(codeBase, dobfile);
            DOBStream = new DataInputStream(new BufferedInputStream(DOBSource.openStream()));
         } catch (Exception e)
         {
//            System.out.println("Maailmatiedoston avaaminen eponnistui.");
         }

         tempWorld.loadDOB(DOBStream);

         try {
            DOBStream.close();
         } catch (Exception e) {}
      }
//      myVecAnim = new vAnim( vAnim.BUFFERED, 3, myWorld, this );

      tempWorld.backGroundMode = true;

      return tempWorld;
   }


/*******************************************************

   scroll stuph

 *******************************************************/

   int[] scrollbg = null;
   byte[] veryarray = null;

   public void initScroll()
   {
      scrollbg = Animation.grabImage(getImage(codeBase, "scrollbg.jpg"));
      veryarray = Animation.grabMask(Animation.grabImage(getImage(codeBase, "verytext.gif")), 360*72);

      scrollX = 0;

      myWorld = initVectors("veryvery.dob", vFace.PHONG);
      myWorld.initScrollVec();
      vFace.environment = Animation.grabImage(getImage(codeBase, "f2.jpg"));
   }

   int scrollX = 0;
   int verystage = 0;
   double scrollSinus = -Math.PI*0.5;

   int[] poswidth = {0,0,
                     0,28,0,67,0,108,0,202,
                     8640,28,8640,67,8640,108,8640,172,
                     17280,28,17280,67,17280,108,17280,166};

   public boolean playScroll()
   {
      while(demoStage < 35)
      {
         scrollX++;
         if (scrollX > 800-360) scrollX = 0;

         if (demoStage < 23)
         {
            if (scrollSinus < 0)
            {
               scrollSinus += 0.1;
            }
            else scrollSinus = 0;
         }
         else scrollSinus = 0;

         if (demoStage > 22)
         {
            if (lastDrawnStage != demoStage)
            {
               lastDrawnStage = demoStage;

               verystage = (demoStage - 22)*2;
            }
            myWorld.updateScrollVec(1);		// siirretn obu ruudulle
         } else myWorld.updateScrollVec(0);	// tai odotellaan...

         drawScroll();

         myWorld.renderView();

         if (!renderView()) return false;
      }

	myWorld.moveStage = 0.0F;

      myWorld.destX = 0.0F;
      myWorld.destY = 0.0F;
      myWorld.destZ = -100.0F;

      myWorld.sourceX = 280.0F;
      myWorld.sourceY = 100.0F;
      myWorld.sourceZ = 200.0F;

      while(demoStage < 36)
      {
         scrollX++;
         if (scrollX > 800-360) scrollX = 0;

         drawScroll();

         myWorld.updateScrollVec(1);
         myWorld.renderView();

         if (!renderView()) return false;
      }

      myWorld.sourceX = 650.0F;
      myWorld.sourceY = 200.0F;
      myWorld.sourceZ = 250.0F;

      verystage = 0;

      while(demoStage < 37)
      {
         scrollX++;
         if (scrollX > 800-360) scrollX = 0;

         drawScroll();

         myWorld.updateScrollVec(3);
         myWorld.renderView();

         if (!renderView()) return false;
      }

      while(demoStage < 38)
      {
         scrollX++;

         if (scrollX > 800-360) scrollX = 0;

         if (scrollSinus > -Math.PI*0.5)
         {
            scrollSinus -= 0.2;
         }
         else scrollSinus = -Math.PI*0.5;

         drawScroll();

         if (!renderView()) return false;
      }

      return true;
   }

   public void drawScroll()
   {
      int scrollY = (int) (113 * (Math.cos(scrollSinus)-1.0));

      if (scrollY < -112) scrollY = -112;
      if (scrollY > 0) scrollY = 0;

      int soffs = scrollX - scrollY * 800;
      int offs = 0;
      int he = 112 + scrollY;

      for(int v=0;v<he;v++)
      {
         for(int u=0;u<360;u++)
         {
            videoBuffer[offs++] = scrollbg[soffs++];
         }
         soffs += 800-360;
      }
      for(;offs<360*180;offs++) videoBuffer[offs] = 0xffffffff;

      soffs = poswidth[verystage];
      int veryWidth = poswidth[verystage+1];

      if (verystage > 0)
      {
         offs = 360*88 + (360-veryWidth)/2;

         for(int v=0;v<24;v++)
         {
            for(int u=0;u<veryWidth;u++)
            {
               int c = (int) veryarray[soffs++];

               if (c < 127)
               {
                  int rb = videoBuffer[offs] ^ -1;
                  int g = rb & 0xff00;
                  rb &= 0xff00ff;

                  videoBuffer[offs] = ((((rb * c) & 0x7f807f80) |
                                       ((g * c) & 0x07f8000)) >> 7) ^ -1;
               }

               offs++;
            }

            soffs += 360-veryWidth;
            offs += 360-veryWidth;
         }
      }

//      return playEnvVectors();
//      return renderView();
   }

/*******************************************************

 *******************************************************/

   Animation greetsAnim = null;
   Animation logoAnim = null;

   int[] greetbg = null;
   byte[] egoend = null;

   public void initLines()
   {
      greetsAnim = loadAnim("greet0.jpg", 4, Animation.IMAGE);
      logoAnim = loadAnim("ego.gif", 14, Animation.BYTEMASK);

      myWorld2 = initVectors("liikenne.dob", vFace.LINE);

      linefadebg = greetsAnim.getIntFrame(3);
      greetbg = greetsAnim.getIntFrame(0);

      egoend = Animation.grabMask(Animation.grabImage(getImage(codeBase, "ego-end.gif")), 370*190);

      for(int i=0;i<360*180;i++) greetbg[i] ^= -1;
   }

   public void fadeWhite(int v, int[] source, int[] dest)
   {
      v >>= 1;
      if (v > 127) v = 127;

      for(int i=0;i<360*180;i++)
      {
         int rb = source[i] ^ -1;
         int g = rb & 0xff00;
         rb &= 0xff00ff;

         dest[i] = ((((rb * v) & 0x7f807f80)
                 | ((g * v) & 0x007f8000)) >> 7) ^ -1;
      }
   }

   int[] linefadebg = null;

   public boolean fadeInLines()
   {
      for(int i=0;i<5;i++)
      {
         fadeWhite(i*51, linefadebg, videoBuffer);
         if (!renderView()) return false;
      }

      for(int framen=3;framen>=0;framen--)
      {
         if (!renderImage(greetsAnim.getImageFrame(framen))) return false;
         if (!wait(140)) return false;
      }
      return true;
   }

   public boolean fadeOutLines()
   {
      for(int framen=0;framen<4;framen++)
      {
         if (!renderImage(greetsAnim.getImageFrame(framen))) return false;
         if (!wait(140)) return false;
      }

      for(int i=5;i>=0;i--)
      {
         fadeWhite(i*51, linefadebg, videoBuffer);
         if (!renderView()) return false;
      }

      while(demoStage == 47)
      {
         if (!wait(35)) return false;
      }

      return true;
   }

   int logoshade = 1;

   public boolean playLines()
   {
      if (!fadeInLines()) return false;
// demoStage == 45..
      while(demoStage < 47)
      {
         if (demoStage == 45)
         {
            byte[] logobuf = logoAnim.getByteMask(framen/2);

            for(int i=0;i<360*180;i++)
            {
               videoBuffer[i] = ((int) logobuf[i]) << logoshade;
            }

            framen ++;
			
		if (timeStamp - prevTimeStamp > 140) framen ++; 
		prevTimeStamp = timeStamp; 

            if (framen >= logoAnim.count)
            {
               framen = 0;
               logoshade ^= 3;
            }
         }
         else
         {
// demoStage == 46
            int soffs = (int) (Math.random()*10) + 370 * (int) (Math.random() * 10);
            int doffs = 0;

            for(int y=0;y<180;y++)
            {
               for(int x=0;x<360;x++)
               {
                  videoBuffer[doffs++] = ((int) egoend[soffs++]) << 3;
               }

               soffs += 10;
            }
         }

         drawLines();
         if (!renderView()) return false;
      }

      return fadeOutLines();
   }

   public void drawLines()
   {
      myWorld2.updateWorld();
      myWorld2.renderView();

      for(int i=0;i<360*180;i++)
      {
         int v = (videoBuffer[i] >> 3) ^ 127;
         if ((v & 0xffff) > 127) v = 0;

         int rb = greetbg[i];
         int g = rb & 0x00ff00;
         rb &= 0xff00ff;

         videoBuffer[i] = ((((rb * v) & 0x7f807f80)
                        | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;
      }
   }

/*******************************************************

   beginning

 *******************************************************/

   Image walkImage = null;
   Animation mercyh = null;

   Image mercyImage = null;
   Graphics mercyG = null;
   Graphics mercyG2 = null;

   Animation egoImages = null;
   Animation screamImages = null;

   Image goImage = null;
   Image ippinImage = null;
   Image egoImage = null;
   Image trippinImage = null;

   Image trashImage = null;
   Image[] smtrash = null; 

   public void initMercy()
   {
	smtrash = new Image[3];
	smtrash[0] = getImage(codeBase, "trash1.gif");
	smtrash[1] = getImage(codeBase, "trash2.gif");
	smtrash[2] = getImage(codeBase, "trash3.gif");

      walkImage = getImage(codeBase, "walkie.jpg");
      waitImage(walkImage);

      trashImage = getImage(codeBase, "trash.gif");
      waitImage(trashImage);

      mercyh = loadAnim("mercy0.gif", 4, Animation.IMAGE);

      egoImages = loadAnim("e-g-o-.gif", 9, Animation.IMAGE);
      screamImages = loadAnim("scr0.jpg", 10, Animation.IMAGE);

      mercyImage = createImage(360,180);
      mercyG = mercyImage.getGraphics();
      mercyG2 = mercyImage.getGraphics();
      mercyG2.clipRect(259,0,101,180);

      goImage = getImage(codeBase, "go.jpg");
      ippinImage = getImage(codeBase, "ippin.jpg");
      egoImage = getImage(codeBase, "ego.jpg");
      trippinImage = getImage(codeBase, "trippin.jpg");

      waitImage(goImage);
      waitImage(ippinImage);
      waitImage(egoImage);
      waitImage(trippinImage);
   }

   int trashSpeed = -10;	

   int walkieX = -180;
   int[] egoIndex = {0,1,2,4,5,6,7,7,6,3};

   int lastDrawnStage = -1;

   int trashY = 150;

   public boolean playMercy()
   {
      while(demoStage < 6)
      {
	   if (demoStage < 2)
	   {
            if (Math.random() < 0.2)
            {
               int yy = (int) (Math.random()*180);
               mercyG.drawImage(walkImage, walkieX, yy - 180, null);
               mercyG.drawImage(walkImage, walkieX, yy, null);
            }
            else mercyG.drawImage(walkImage, walkieX, 0, null);

            trashY -= trashSpeed;	// trashSpeed

            trashSpeed *= 13;
	      trashSpeed -= 23;

            trashY = (trashY % 200) - 20;

	      mercyG.drawImage(trashImage, trashY - 50, trashY + (int) (Math.random()*20), null);
		for(int tr=0;tr<3;tr++)
		{
		   mercyG.drawImage(smtrash[tr], (int) (Math.random()*360), (int) (Math.random()*180), null);
		}
	   } 
	   else 
	   {
		mercyG.drawImage(walkImage, walkieX, 0, null);
		mercyG.drawImage(mercyh.getImageFrame(demoStage-2), 0, 0, null);
	   }

         walkieX++;

         if (!renderImage(mercyImage)) return false;
      }

      while(demoStage < 16)
      {
         if (lastDrawnStage != demoStage)
         {
            lastDrawnStage = demoStage;

            if ((demoStage & 1) == 0)
            {
               mercyG.drawImage(egoImages.getImageFrame(egoIndex[demoStage-6]), 0, 0, null);
               mercyG.drawImage(screamImages.getImageFrame(demoStage-6), 168, 0, null);
            }
            else
            {
               mercyG.drawImage(egoImages.getImageFrame(egoIndex[demoStage-6]), 192, 0, null);
               mercyG.drawImage(screamImages.getImageFrame(demoStage-6), 0, 0, null);
            }

            if (!renderImage(mercyImage)) return false;
         }
         else
         {
            if (!wait(70)) return false;
         }
      }

      while(demoStage < 22)
      {
         if (lastDrawnStage != demoStage)
         {
            lastDrawnStage = demoStage;

            if (demoStage == 19)
            {
               egoImage = trippinImage;
               goImage = ippinImage;
            }

            mercyG.drawImage(egoImage, 0, 0, null);

            int ss = (demoStage - 16) % 3;

            switch (ss)
            {
               case 0:
               {
                  mercyG.drawImage(goImage, 100, 0, null);
                  break;
               }
               case 1:
               {
                  mercyG2.drawImage(goImage, 100, 0, null);
                  break;
               }
            }
            if (!renderImage(mercyImage)) return false;
         }
         else if (!wait(20)) return false;
      }

//      System.out.println("now done with mercy");

      return true;
   }

/*******************************************************

   chaos 'n' stuph

 *******************************************************/

   public void initChaos()
   {
      imgbuf = Animation.grabImage(getImage(codeBase, "tausta.jpg"));

      for(int i=0;i<width*height;i++)
         imgbuf[i] &= 0x00fcfcfc;

      if (vectMapArray == null)
      {
/*
         if (vidg != null)
         {
            vidg.drawString("Lasken vektorikentti",4,28);
            vidg.drawRect(4,30,width-8,9);
         }
         repaint();
*/
         vectMapArray = new int[mapcount][];

         int[] temp = new int[mapwidth*mapheight];
//         zoomMap(temp, 93, 60, 0.08, 8, 2, 0);
//         finishMap(zoomMap(temp, 93, 60, 0.04, 64, 2, 0));
         zoomMap(temp, width/2, height/2, 0.08, 8, 2, 0);
         finishMap(zoomMap(temp, width/2, height/2, 0.04, 64, 2, 0));
         vectMapArray[0] = temp;

//         donebar(1);

         temp = new int[mapwidth*mapheight];
         rotateMap(temp, width/2, height/2, 0.0002, -0.4);
         tileMap(temp,10,5);

         finishMap(temp);
         vectMapArray[1] = temp;

//         donebar(2);

         temp = new int[mapwidth*mapheight];
         rotateMap(temp, width/2, height/2, 0.0002, 0.4);
         zoomMap(temp,width/2,height/2,0.04,5,1,0);

         finishMap(temp);
         vectMapArray[2] = temp;

//         donebar(3);

         temp = new int[mapwidth*mapheight];
         sinusMap(temp, 0.02, 10.0, 0.083, -4.0);
         zoomMap(temp,width/2,height/2,-0.14,0,1,0);

         finishMap(temp);
         vectMapArray[3] = temp;

//         donebar(4);
      }

      if (vectMap0 == null) setmap(0);
   }

   public boolean playChaos()
   {
//      System.out.println("starting chaos (why already?)");
// demoStage == 52

      while(demoStage < 54)
      {
         if (demoStage == 53 && lastDrawnStage != 53)
         {

//            System.out.println("starting fade from chaos");

            for(int i=0;i<360*180;i++) imgbuf[i] = 0x00fcfcfc;

            bgstage = 500000;
            bgon = true;

            lastDrawnStage = 53;
         }

         astage ++;
         astage2 ++;

//         mapy = (int) (mapmodulo / 2);
//         mapx = (int) (mapmodulo / 4);
         mapy = (int) (mapmodulo / 8.0 * (4.0 + Math.sin(astage*0.08) + Math.sin(astage2*0.0317)));
         mapx = (int) (mapmodulo / 16.0 * (4.0 + Math.sin(astage*0.122) + Math.sin(astage2*0.0235)));

         if (demoStage == 53)
         {
            mapy = (int) (mapmodulo / 2);
            mapx = (int) (mapmodulo / 4);
         }

         if (bgstage--<0)
         {
            bgstage = 20; // + (int) (10 * Math.random());
            bgon = !bgon;
/*
            if (bgon)
            {
               bgstage >>=1;
            }
*/
         }

         if (mstage--<0)
         {
            setmap(mapid+1);
            mstage = 30; // + (int) (60 * Math.random());
         }

         makeWorldGo();

         if (!renderView()) return false;
      }

      return true;
   }

/*******************************************************

 *******************************************************/

   Animation koneAnim = null;
   vWorld koneWorld = null;
   byte[] credits = null;

   public void initCredits()
   {
      koneAnim = loadAnim("kone0.jpg", 9);

      koneWorld = initVectors("kone.dob", vFace.LINE);
      credits = Animation.grabMask(Animation.grabImage(getImage(codeBase, "credits.gif")), 360*20);
   }

   final int cColor = 0xff000066;
   final int crb = 0x66;
   final int cg = 0x00;

   int fadeval = 127*8;
   int credy = -20;

   public boolean playCredits()
   {
//      System.out.println("kone: 54? 115100?");

// demoStage == 54
      while(demoStage < 56)
      {
         fadeval -= 8*8;
         if (fadeval < 0)
         {
            fadeval = 0;
            if (credy < 0) credy += 2;
         }

         if (demoStage == 55)
         {
            fadeval += 14*8;
            credy -= 4;
         }

         int[] myFrame = koneAnim.getIntFrame(framen / 2);

         framen += frameinc;

         if ((framen & 0xff) >= koneAnim.count*2)
         {
            frameinc = - frameinc;
            framen += (frameinc*2);
         }

         for(int i=0;i<360*180;i++) videoBuffer[i] = fadeval;

         koneWorld.koneupdateWorld();
         koneWorld.renderView();

         for(int i=0;i<360*180;i++)
         {
            int v = (videoBuffer[i] >> 3) ^ 127;
            if ((v & 0xffff) > 127) v = 0;

            int rb = myFrame[i] ^ -1;
            int g = rb & 0x00ff00;
            rb &= 0xff00ff;

            videoBuffer[i] = ((((rb * v) & 0x7f807f80)
                           | ((g * v) & 0x007f8000)) >> 7) ^ 0xffffffff;
         }

         int offs = 360*credy;
         int soffs = 0;
         int hee = 20;

         if (credy < 0)
         {
            offs = 0;
            soffs = - 360 * credy;
            hee += credy;
         }
			
	   hee *= 360;

	   int murkmuuttuja = (int) (Math.random() * 5)
				  + 360 * ((int) (Math.random() * 5));

	   hee -= murkmuuttuja;
	   soffs += murkmuuttuja;

         for(int v=0;v<hee;v++)
         {
            int c = (int) credits[soffs++];

            if (c != 127)
            {
               if (c == 0)
               {
                  videoBuffer[offs] = cColor;
               }
               else
               {
                  int rb = videoBuffer[offs];
                  int g = rb & 0xff00;
                  rb &= 0xff00ff;

                  videoBuffer[offs] = ((((rb * c + crb * (128-c)) & 0x7f807f80) |
                                       ((g * c + cg * (128-c)) & 0x07f8000)) >> 7) | 0xff000000;
               }
            }
            offs++;
         }

         if (!renderView()) return false;
      }

      return true;
   }

/*******************************************************

   initplayanim

 *******************************************************/

   Animation sncAnim = null;
   Image endlogo = null;

   public void initPlayAnim()
   {
      endlogo = getImage(codeBase, "java-end.gif");
      waitImage(endlogo);

      videoImage = endlogo;
      repaint();

      sncAnim = loadAnim("cha.gif", 52, Animation.IMAGE);

      for(int i=0;i<52;i++)
      {
         waitImage(sncAnim.getImageFrame(i));
      }

      for(int i=0;i<75;i++)
      {
         if (!renderImage(sncAnim.getImageFrame(i % 51))) return;
      }

	renderImage(sncAnim.getImageFrame(51));

/*
      for(int i=0;i<360*180;i++) videoBuffer[i] = -1;
      renderView();
*/
   }

/*******************************************************

 *******************************************************/

      Image javalogo = null;
      Image emptybar = null;
      Image fullbar = null;
      Image ostext = null;

      int osdone = 0;

      int[] undonex = {151,108,101,184};

      public void osstart(int text, int percent)
      {
         vidg.setColor(Color.white);
         vidg.fillRect(0,0,360,180);
         vidg.drawImage(javalogo,154,36,null);
         vidg.drawImage(emptybar,51,148,null);

         Graphics gnew = videoImage.getGraphics();

         int xx = undonex[text];
         if (percent == 100)
         {
            xx = 266;
         }
         gnew.clipRect(53,134,xx,14);

         gnew.drawImage(ostext, 53, 134-text*14, null);

         gnew = videoImage.getGraphics();

         if (percent != 100)
         {
            gnew.clipRect(53,150,266*percent/100,14);
         }

         gnew.drawImage(fullbar, 53, 150, null);

         repaint();
      }

/*******************************************************

 *******************************************************/


 /*
   public String[][] getParameterInfo() {
      String[][] info = {
        // Parameter Name     Kind of Value  Description
         {"distance",         "int",         "distance of lightsource (25)"},
         {"intensity",        "int",         "intensity of lightsource (100%)"},
         {"ambient",          "int",         "ambient light (20%)"},
         {"diffuse",          "int",         "diffuse light (60%)"},
         {"specular",         "int",         "specular light (20%)"},
         {"falloff",          "int",         "falloff value for specular light (4)"},
         {"shininess",        "int",         "shininess of material (100%)"},
      };
      return info;
   }
*/
   public String getAppletInfo()
   {
      return("egotrippin demonstration Copyright (c) Sonik Clique in 1997");
   }
}
