/*

    vAnimThread...

*/

public class vAnimThread extends java.lang.Thread implements Runnable
{
   vAnim myHost = null;
   vWorld myWorld = null;
   int frameCount = 0;
   int startId = 0;

   public vAnimThread( int newStartId, int newFrameCount, vWorld animSource, vAnim newHost )
   {
      frameCount = newFrameCount;
      myWorld = animSource;
      myHost = newHost;
      startId = newStartId;
   }

   public void run()
   {
      if (myHost.animType == vAnim.LOOPING)
      {
         for(int i=0;i<frameCount;i++)
         {
            System.out.println("vAnimThread preparing frame " + i + "/" + frameCount);
            myWorld.updateWorld();
            myHost.setNewImageArray( startId+i, myWorld.renderView() );
            Thread.yield();
         }
      }
      else
      {
         int i=0;
         while( myHost.animThread != null)
         {
            myWorld.updateWorld();
            myHost.setNewImageArray( startId+i++, myWorld.renderView() );
            Thread.yield();
         }
      }

      System.out.println("vAnimThread done!");
      myHost.animThread = null;
   }
}