/********************************************************

    vMatrix

 ********************************************************/

public class vMatrix
{
   float r00, r01, r02;
   float r10, r11, r12;
   float r20, r21, r22;

   public vMatrix()
   {
      r00 = 1.0F;
      r01 = 0.0F;
      r02 = 0.0F;
      r10 = 0.0F;
      r11 = 1.0F;
      r12 = 0.0F;
      r20 = 0.0F;
      r21 = 0.0F;
      r22 = 1.0F;
   }

   public final void copyMatrix( vMatrix dest )
   {
      dest.r00 = r00;
      dest.r01 = r01;
      dest.r02 = r02;

      dest.r10 = r10;
      dest.r11 = r11;
      dest.r12 = r12;

      dest.r20 = r20;
      dest.r21 = r21;
      dest.r22 = r22;
   }

/********************************************************

    void dotProduct( source, dest )

    - sijoittaa dest:iin sourcen ja tmn pistetulon

 ********************************************************/

   public final void dotProduct( vMatrix source, vMatrix dest )
   {
      float s00 = source.r00;
      float s01 = source.r01;
      float s02 = source.r02;

      float s10 = source.r10;
      float s11 = source.r11;
      float s12 = source.r12;

      float s20 = source.r20;
      float s21 = source.r21;
      float s22 = source.r22;

      dest.r00 = s00 * r00 + s01 * r10 + s02 * r20;
      dest.r01 = s00 * r01 + s01 * r11 + s02 * r21;
      dest.r02 = s00 * r02 + s01 * r12 + s02 * r22;

      dest.r10 = s10 * r00 + s11 * r10 + s12 * r20;
      dest.r11 = s10 * r01 + s11 * r11 + s12 * r21;
      dest.r12 = s10 * r02 + s11 * r12 + s12 * r22;

      dest.r20 = s20 * r00 + s21 * r10 + s22 * r20;
      dest.r21 = s20 * r01 + s21 * r11 + s22 * r21;
      dest.r22 = s20 * r02 + s21 * r12 + s22 * r22;
   }
}