/********************************************************

    vNormal

 ********************************************************/

public class vNormal
{
   public static vNormal normalList = null;

   public int   x, y, z;
   public int   rx, ry, rz;

   public vNormal nextNormal = null;
   public vNormal prevNormal = null;

/********************************************************

   vNormal( x, y, z )

   - constructor
   - luo vNormal objektin

 ********************************************************/

   public vNormal( int nx, int ny, int nz )
   {
      x = nx;
      y = ny;
      z = nz;

      nextNormal = normalList;
      if (nextNormal != null) nextNormal.prevNormal = normalList = this;
   }

   public boolean isEqual( vNormal norm )
   {
      return isEqual( norm.x, norm.y, norm.z );
   }

   public boolean isEqual( int nx, int ny, int nz )
   {
      if ((nx == x) && (ny == y) && (nz == z)) return true;
      return false;
   }

   public vNormal normalize( int r )
   {
      float t;

      t = r / (float) Math.sqrt( x*x+y*y+z*z );

      x = (int) (((float) x) * t);
      y = (int) (((float) y) * t);
      z = (int) (((float) z) * t);

      vNormal temp = nextNormal;

      while( temp != null )
      {
         if (isEqual( temp ))
         {

// jos vastaava normaali on jo olemassa, poistetaan tm listasta
// ja palautetaan se

            if (nextNormal != null) nextNormal.prevNormal = prevNormal;
            if (prevNormal != null) prevNormal.nextNormal = nextNormal;
            return temp;
         }

         temp = temp.nextNormal;
      }

      return this;
   }

/********************************************************

    vNormal add( normal )

    - lis vektorin normaaliin

 ********************************************************/

   public vNormal add( vNormal newNormal )
   {
      x += newNormal.x;
      y += newNormal.y;
      z += newNormal.z;
      return this;
   }

/********************************************************

    vNormal rotate()

    - pyritt normaalin

 ********************************************************/

   public vNormal rotate(vMatrix rm)
   {
/*
      private float r00 = rm.r00;
      private float r01 = rm.r01;
      private float r02 = rm.r02;
      private float r10 = rm.r10, r11 = rm.r11, r12 = rm.r12;
      private float r20 = rm.r20, r21 = rm.r21, r22 = rm.r22;
*/
      return this;
   }
}